; #########################################################################
.NOLIST
      .386
      .model flat, stdcall
      option casemap :none   ; case sensitive

; #########################################################################

	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \MASM32\include\advapi32.inc	;pour les services

	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\advapi32.lib
	
	include macro.inc	
	
	essai 				PROTO 
	;----------------------- proto service --------------
	InstalleService  		PROTO   
	ServiceMain 			PROTO  :DWORD,  :DWORD ;normalis windows
	CtrlHandler 			PROTO  :DWORD 
	SendStatus 			PROTO  :DWORD,  :DWORD,  :DWORD,  :DWORD,  :DWORD 	
	ResumeService 		PROTO 
	PauseService 			PROTO 
	StopService 			PROTO 
	InitServiceThread 		PROTO 
	ServiceThread 		PROTO
	Desinstalle 			PROTO 
	RetrouveMessageErreur 	PROTO :DWORD   ;des messages systemes dans la langue 
							 ;que vous voulez
	
	;--------- pas dans windows.inc ----------------------------
	SERVICE_CONFIG_DESCRIPTION      equ   1
	SERVICE_CONFIG_FAILURE_ACTIONS  equ   2	

	SERVICE_DESCRIPTION STRUCT
		lpDescription dd ?
	SERVICE_DESCRIPTION ENDS

.data
;----------------------- data service ---------------------------
ServicesDatabase dd 0
ServiceHandle    dd 0
ServiceName Db "Mon service",0
ServiceDescription db "Modele de service,ne fait rien,relancer le prog pour le suprimer",0
OsVer OSVERSIONINFO <sizeof OSVERSIONINFO,,,,,>
ServiceDesc SERVICE_DESCRIPTION <ServiceDescription>	;dcrite plus haut
ServiceStatusTable SERVICE_STATUS <>
ServiceTable SERVICE_TABLE_ENTRY<ServiceName,ServiceMain>
ServiceCurrentStatus dd 0
ServiceEvent dd 0
ServiceStatus dd 0
hServiceThread dd 0

    .code
;@@@@@@@@@@@@@@@@@@@@@@@      POINT d'ENTREE        @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
start:
DebutdeProgramme:
.LISTALL
;------------------------------------------------
.LISTALL
	call essai	;tester trois tats diffrents du service
	;xcuter de nouveau le programme pour dsinstaller	
	invoke ExitProcess,0
	
;################################################################
essai PROC 
			Local  retour:DWORD
	mov retour,1
	;--------------- ouvrir la base de donnes ----------------------------
	mov ServicesDatabase,FUNC(OpenSCManager,NULL, NULL, SC_MANAGER_CREATE_SERVICE)
	.if ServicesDatabase == 0
		invoke RetrouveMessageErreur,SADR ("OpenSCManager")
		mov eax,0
		ret
	.endif
	;------- voir si le service est dja cr ------------------------------------
	mov ServiceHandle,FUNC(OpenService,ServicesDatabase,addr ServiceName, SERVICE_ALL_ACCESS)
	.if ServiceHandle == 0			;le service n'est pas install
		invoke InstalleService		;installer le service
		mov retour,eax
		.if eax != 0			
			invoke MessageBox,NULL,ADDR ServiceName,SADR("Service Install"),MB_OK
		.endif
		jmp Findeessai
	.endif
	;--------------- le service est dja install --------------------------------
	invoke QueryServiceStatus,ServiceHandle,addr ServiceStatusTable
	
	;------------- le service dmarre,installer les routines du service	----------
	.if ServiceStatusTable.dwCurrentState == SERVICE_START_PENDING ;--requte systme
		invoke CloseServiceHandle,ServiceHandle
		invoke StartServiceCtrlDispatcher,addr ServiceTable
		.if eax == 0
			invoke RetrouveMessageErreur, SADR("StartServiceCtrlDispatcher")
		.endif
	.else
	;------------------- dsinstall ---------------------------------------
		invoke Desinstalle
	.endif

 Findeessai:
	invoke CloseServiceHandle,ServicesDatabase		
         mov eax,retour
         ret
essai endp


;################################################################
InstalleService PROC   
			;Local   :DWORD
			Local    FileName[MAX_PATH +1]:BYTE 
			Local    retour:DWORD
			ZEROLOCALES retour
						
	mov retour,1
	invoke GetModuleFileName,0,addr FileName,sizeof FileName
	;--- crer le service immdiatement ,StartType ---------------
	
	Invoke CreateService,ServicesDatabase,addr ServiceName,addr ServiceName,\
		SERVICE_ALL_ACCESS,SERVICE_WIN32_OWN_PROCESS + SERVICE_INTERACTIVE_PROCESS,\
		SERVICE_DEMAND_START,SERVICE_ERROR_NORMAL,addr FileName,NULL, NULL, NULL, NULL, NULL
		
	mov ServiceHandle,eax
	.if ServiceHandle != 0
		invoke GetVersionEx,addr OsVer
		;MajorVersion
		.if OsVer.dwMajorVersion >= 5 && OsVer.dwPlatformId == VER_PLATFORM_WIN32_NT
			;rajouter la description du service
			invoke ChangeServiceConfig2,ServiceHandle,\
				SERVICE_CONFIG_DESCRIPTION,addr ServiceDesc	
		
		.endif
	.else
		invoke RetrouveMessageErreur,SADR ("InstalleService CreateService")	
		mov retour,0
		jmp FindeInstalleService		
	.endif
	;----------------- dmarrer le service -----------------------------------------
	invoke StartService,ServiceHandle, 0, 0
	.if eax == 0
		invoke RetrouveMessageErreur,SADR ("InstalleService StartService")
	.endif
	;----------- dans tous les cas fermer les handles
	invoke	CloseServiceHandle,ServiceHandle
	
 FindeInstalleService:
         mov eax,retour
         ret
InstalleService endp


;################################################################
Desinstalle PROC 
			Local  retour:DWORD
       mov retour,1	
	;---------------- service dja ouvert ---------------------
	;--------------- arrter le service s'il ne l'est pas ----------------
	invoke QueryServiceStatus,ServiceHandle, addr ServiceStatusTable
	.if ServiceStatusTable.dwCurrentState != SERVICE_STOPPED
		invoke ControlService,ServiceHandle, SERVICE_CONTROL_STOP,addr ServiceStatusTable
		invoke Sleep,500
	.endif
	invoke DeleteService,ServiceHandle ;marks the specified service for deletion from 
						 ;the service control manager database. 
	.if eax != 0
		invoke MessageBox,NULL,SADR("Service dsinstall"),\
				addr ServiceName, MB_OK + MB_ICONINFORMATION
		mov retour,1
	.else
		invoke MessageBox,NULL,SADR("Impossible d'enlever le service"),\
				addr ServiceName, MB_OK + MB_ICONINFORMATION
		mov retour,0	
	.endif
	invoke CloseServiceHandle,ServiceHandle

 FindeDesinstalle:
         mov eax,retour
         ret
Desinstalle endp


;################################################################
;appel par StartServiceCtrlDispatcher ,ne revient pas tant que tout n'est pas termin
;en premier elle doit appeler RegisterServiceCtrlHandler
ServiceMain PROC  Nbarg:DWORD,  AdrTabl:DWORD 
			Local  retour:DWORD
       mov retour,1
	mov ServiceStatus,FUNC(RegisterServiceCtrlHandler,addr ServiceName,addr CtrlHandler)
	.if ServiceStatus == 0
			invoke RetrouveMessageErreur,SADR("ServiceMain ServiceStatus")
			mov retour,0
			jmp FindeServiceMain
	.endif
	invoke SendStatus,SERVICE_START_PENDING, NO_ERROR, 0, 1, 5000
	mov ServiceEvent,FUNC(CreateEvent,0, TRUE, FALSE, 0)
	.if ServiceEvent == 0
			invoke RetrouveMessageErreur,SADR("ServiceMain SendStatus")
			mov retour,0	
			jmp FindeServiceMain
	.endif
	invoke SendStatus,SERVICE_START_PENDING, NO_ERROR, 0, 2, 1000
	invoke SendStatus,SERVICE_START_PENDING, NO_ERROR, 0, 3, 5000
	invoke InitServiceThread
	.if  eax == 0
		invoke RetrouveMessageErreur,SADR("ServiceMain SendStatus")	
		mov retour,0
		jmp FindeServiceMain
	.endif
	invoke SendStatus,SERVICE_RUNNING, NO_ERROR, 0, 0, 0
	;------------ boucle d'attente --------------------------------
	invoke WaitForSingleObject,ServiceEvent,INFINITE

 FindeServiceMain:
         mov eax,retour
         ret
ServiceMain endp

;################################################################
; --------------- rpond aux messages du systme -------

CtrlHandler PROC  CtrlCode:DWORD 
			Local  retour:DWORD
			Local  StatetoSend:DWORD
	mov retour,1
	mov StatetoSend,0	
	.IF CtrlCode == SERVICE_CONTROL_STOP
		invoke SendStatus,SERVICE_STOP_PENDING, NO_ERROR, 0, 1, 5000
		invoke StopService
		mov StatetoSend,SERVICE_STOPPED
	.elseif CtrlCode == SERVICE_CONTROL_PAUSE
		.if ServiceCurrentStatus == 1			
			invoke SendStatus,SERVICE_PAUSE_PENDING, NO_ERROR, 0, 1, 1000
			invoke PauseService
			mov StatetoSend,SERVICE_PAUSED
		.endif
	.elseif CtrlCode == SERVICE_CONTROL_CONTINUE
		.if ServiceCurrentStatus == 3
			invoke SendStatus,SERVICE_CONTINUE_PENDING, NO_ERROR, 0, 1, 1000
			invoke ResumeService
			mov StatetoSend,SERVICE_RUNNING
		.endif
	.elseif CtrlCode == SERVICE_CONTROL_SHUTDOWN
		jmp FindeCtrlHandler
	.endif
	
	invoke SendStatus,StatetoSend, NO_ERROR, 0, 0, 0
	
 FindeCtrlHandler:
         mov eax,retour
         ret
CtrlHandler endp

;################################################################


SendStatus PROC  dwCurrentState:DWORD,dwWin32ExitCode:DWORD,\
			dwServiceSpecificExitCode:DWORD,dwCheckPoint:DWORD,dwWaitHint:DWORD 
			Local  retour:DWORD
         mov retour,1
	mov ServiceStatusTable.dwServiceType,SERVICE_WIN32_OWN_PROCESS
	PuPo ServiceStatusTable.dwCurrentState,dwCurrentState
	.if dwCurrentState == SERVICE_START_PENDING
	 	mov ServiceStatusTable.dwControlsAccepted,0
	.else 
		mov ServiceStatusTable.dwControlsAccepted,\
		SERVICE_ACCEPT_STOP + SERVICE_ACCEPT_PAUSE_CONTINUE + SERVICE_ACCEPT_SHUTDOWN
	.endif
	.if dwServiceSpecificExitCode == 0
		PuPo ServiceStatusTable.dwWin32ExitCode,dwWin32ExitCode
	.else
	 	mov ServiceStatusTable.dwWin32ExitCode,ERROR_SERVICE_SPECIFIC_ERROR
	.endif
	
	PuPo ServiceStatusTable.dwServiceSpecificExitCode,dwServiceSpecificExitCode
	PuPo ServiceStatusTable.dwCheckPoint,dwCheckPoint
	PuPo ServiceStatusTable.dwWaitHint,dwWaitHint
	invoke SetServiceStatus,ServiceStatus,addr ServiceStatusTable
 FindeSendStatus:
         mov eax,retour
         ret
SendStatus endp

;################################################################
; --------------- Resume service 

;################################################################

ResumeService PROC 
			Local  retour:DWORD
         mov retour,1
	and ServiceCurrentStatus,0fffffffh
	invoke ResumeThread,hServiceThread

 FindeResumeService:
         mov eax,retour
         ret
ResumeService endp

;################################################################

PauseService PROC 
			Local  retour:DWORD
      mov retour,1
	or ServiceCurrentStatus,2
	invoke SuspendThread,hServiceThread
 FindePauseService:
         mov eax,retour
         ret
PauseService endp

;################################################################

StopService PROC 
			Local  retour:DWORD
         mov retour,1
	and ServiceCurrentStatus,0fffffffh
	invoke SetEvent,ServiceEvent

 FindeStopService:
         mov eax,retour
         ret
StopService endp

;################################################################

InitServiceThread PROC 
		Local  retour   :DWORD
		LOcal  ThreadID :DWORD
      	mov retour,0
	mov hServiceThread,FUNC(CreateThread,0, 0,ServiceThread, 0, 0,addr ThreadID)
	.if hServiceThread != 0
		or ServiceCurrentStatus,1
		mov retour,1
	.endif

 FindeInitServiceThread:
       mov eax,retour
       ret
InitServiceThread endp

;################################################################

ServiceThread PROC 
			Local  retour:DWORD
         mov retour,1
		;invoke Sleep,10
	
	invoke MessageBox,NULL,SADR("ServiceThread appel"),SADR("Temoin"),MB_OK
	
 FindeServiceThread:
         mov eax,retour
         ret
ServiceThread endp

;################################################################
RetrouveMessageErreur proc lpTitle:DWORD
	
	LOCAL lpMsgBuffer 	: LPVOID
	
	; calculate language ID, asm version of MAKELANGID
	mov cx, SUBLANG_DEFAULT
	shl ecx, 10
	;or  cx, LANG_NEUTRAL		; LANG_NEUTRAL = 0, nothing necessary
	
	; Setup parameters for FormatMessage, normal pushing to use some
	; params directly (e.g. GetLastError returns the ID in eax, but I
	; can't use this register in "invoke")
	
	push NULL					; we don't need this
	push 0						; min. size of output buffer if we use 
								; FORMAT_MESSAGE_ALLOCATE_BUFFER
	lea  eax, lpMsgBuffer 		; get address of our buffer
	push eax					; address of buffer
	push ecx					; our language ID, calculated above
	invoke GetLastError			; get error number
	push eax					; push return value = error ID
	push NULL					; can be used to format a string, we don't need it
	mov edx, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM
	push edx					; some flags, check your doc for more
	call FormatMessage			; here we go
	
	; Display error-message
	invoke MessageBox, NULL, lpMsgBuffer, lpTitle, MB_OK or MB_ICONSTOP
	
	; free memory
	invoke LocalFree, lpMsgBuffer

	ret

RetrouveMessageErreur endp

end start
